# Generated by Selenium IDE
import pytest
import time
import json
from selenium import webdriver
from selenium.webdriver.common.by import By
from selenium.webdriver.common.action_chains import ActionChains
from selenium.webdriver.support import expected_conditions
from selenium.webdriver.support.wait import WebDriverWait
from selenium.webdriver.common.keys import Keys
from selenium.webdriver.common.desired_capabilities import DesiredCapabilities
import tabula
import re
import json
import fitz
import pytesseract
from PIL import Image
import concurrent.futures
from langdetect import detect_langs
import enchant

class TestHsbc():
    def setup_method(self, method):
        self.driver = webdriver.Chrome()
        self.vars = {}

    def teardown_method(self, method):
        self.driver.quit()

    def wait_for_window(self, timeout=2):
        time.sleep(round(timeout / 1000))
        wh_now = self.driver.window_handles
        wh_then = self.vars["window_handles"]
        if len(wh_now) > len(wh_then):
            return set(wh_now).difference(set(wh_then)).pop()

    def test_hsbc(self):
        # Test name: hsbc
        # Step # | name | target | value
        # 1 | open | https://www.hsbc.com.eg/ |
        self.driver.get("https://www.hsbc.com.eg/")
        # 2 | setWindowSize | 1382x744 |
        self.driver.set_window_size(1382, 744)
        # 3 | click | linkText=Log on |
        self.driver.find_element(By.LINK_TEXT, "Log on").click()
        # 4 | click | id=Username1 |
        self.driver.find_element(By.ID, "Username1").click()
        # 5 | type | id=Username1 | ahmedmedhat116
        self.driver.find_element(By.ID, "Username1").send_keys("ahmedmedhat116")
        # 6 | sendKeys | id=Username1 | ${KEY_ENTER}
        self.driver.find_element(By.ID, "Username1").send_keys(Keys.ENTER)
        # 7 | click | id=memorableAnswer |
        self.driver.find_element(By.ID, "memorableAnswer").click()
        # 8 | type | id=memorableAnswer | koshary
        self.driver.find_element(By.ID, "memorableAnswer").send_keys("koshary")
        # 9 | click | css=.row1 > .question |
        self.driver.find_element(By.CSS_SELECTOR, ".row1 > .question").click()
        # 10 | click | id=pass1 |
        self.driver.find_element(By.ID, "pass1").click()
        # 11 | type | id=pass1 | m
        self.driver.find_element(By.ID, "pass1").send_keys("m")
        # 12 | type | id=pass2 | i
        self.driver.find_element(By.ID, "pass2").send_keys("i")
        # 13 | type | id=pass7 | a
        self.driver.find_element(By.ID, "pass7").send_keys("a")
        # 14 | click | css=.submit_input |
        self.driver.find_element(By.CSS_SELECTOR, ".submit_input").click()
        # 15 | runScript | window.scrollTo(0,93.75) |
        self.driver.execute_script("window.scrollTo(0,93.75)")
        # 16 | click | css=#dijit_form_Button_3_label > .icon |
        self.driver.find_element(By.CSS_SELECTOR, "#dijit_form_Button_3_label > .icon").click()
        # 17 | click | css=#dijit_form_Button_3_label > .icon |
        self.driver.find_element(By.CSS_SELECTOR, "#dijit_form_Button_3_label > .icon").click()
        # 18 | click | css=.manage > .icon |
        self.driver.find_element(By.CSS_SELECTOR, ".manage > .icon").click()
        # 19 | click | css=.manage > .icon |
        self.driver.find_element(By.CSS_SELECTOR, ".manage > .icon").click()
        # 20 | click | id=dapViewMoreDownload |
        self.driver.find_element(By.ID, "dapViewMoreDownload").click()
        # 21 | click | css=#hdx_dijits_Dialog_2 .btnSecondary |
        self.vars["window_handles"] = self.driver.window_handles
        # 22 | storeWindowHandle | root |
        self.driver.find_element(By.CSS_SELECTOR, "#hdx_dijits_Dialog_2 .btnSecondary").click()
        # 23 | selectWindow | handle=${win4183} |
        self.vars["win4183"] = self.wait_for_window(2000)
        # 24 | selectWindow | handle=${root} |
        self.vars["root"] = self.driver.current_window_handle
        # 25 | click | id=_dapViewMore |
        self.driver.switch_to.window(self.vars["win4183"])
        # 26 | runScript | window.scrollTo(0,1081) |
        self.driver.switch_to.window(self.vars["root"])
        # 27 | click | id=_dapViewMore |
        self.driver.find_element(By.ID, "_dapViewMore").click()
        # 28 | mouseOver | id=_dapViewMore |
        self.driver.execute_script("window.scrollTo(0,1081)")
        # 29 | mouseOut | id=_dapViewMore |
        self.driver.find_element(By.ID, "_dapViewMore").click()
        # 30 | mouseDown | css=.manage |
        element = self.driver.find_element(By.ID, "_dapViewMore")
        actions = ActionChains(self.driver)
        actions.move_to_element(element).perform()
        # 31 | mouseUp | css=.manage > .icon |
        element = self.driver.find_element(By.CSS_SELECTOR, "body")
        actions = ActionChains(self.driver)
        actions.move_to_element(element, 0, 0).perform()
        # 32 | click | css=.manage |
        element = self.driver.find_element(By.CSS_SELECTOR, ".manage")
        actions = ActionChains(self.driver)
        actions.move_to_element(element).click_and_hold().perform()
        # 33 | mouseOver | linkText=Statements |
        element = self.driver.find_element(By.CSS_SELECTOR, ".manage > .icon")
        actions = ActionChains(self.driver)
        actions.move_to_element(element).release().perform()
        # 34 | click | linkText=Statements |
        self.driver.find_element(By.CSS_SELECTOR, ".manage").click()
        # 35 | runScript | window.scrollTo(0,0) |
        element = self.driver.find_element(By.LINK_TEXT, "Statements")
        actions = ActionChains(self.driver)
        actions.move_to_element(element).perform()
        # 36 | runScript | window.scrollTo(0,0) |
        self.driver.find_element(By.LINK_TEXT, "Statements").click()
        # 37 | click | css=#dijit_form_Button_3_label > .icon |
        self.driver.execute_script("window.scrollTo(0,0)")
        # 38 | click | css=#dijit_form_Button_3_label > .icon |
        self.driver.execute_script("window.scrollTo(0,0)")
        # 39 | runScript | window.scrollTo(0,856.5) |
        self.driver.find_element(By.CSS_SELECTOR, "#dijit_form_Button_3_label > .icon").click()
        # 40 | click | css=.conversionSummary |
        self.driver.find_element(By.CSS_SELECTOR, "#dijit_form_Button_3_label > .icon").click()
        # 41 | click | css=.conversionSummary |
        self.driver.execute_script("window.scrollTo(0,856.5)")
        # 42 | runScript | window.scrollTo(0,1091.151123046875) |
        self.driver.find_element(By.CSS_SELECTOR, ".conversionSummary").click()
        # 43 | click | css=.conversionSummary |
        self.driver.find_element(By.CSS_SELECTOR, ".conversionSummary").click()
        # 44 | click | css=.greyTextFcColr |
        self.driver.execute_script("window.scrollTo(0,1091.151123046875)")
        # 45 | runScript | window.scrollTo(0,825.119384765625) |
        self.driver.find_element(By.CSS_SELECTOR, ".conversionSummary").click()
        # 46 | click | id=_dapViewMore |
        self.driver.find_element(By.CSS_SELECTOR, ".greyTextFcColr").click()
        # 47 | mouseOver | id=_dapViewMore |
        self.driver.execute_script("window.scrollTo(0,825.119384765625)")
        # 48 | mouseOut | id=_dapViewMore |
        self.driver.find_element(By.ID, "_dapViewMore").click()
        # 49 | click | css=.gridxRowOver .moreInfo |
        element = self.driver.find_element(By.ID, "_dapViewMore")
        actions = ActionChains(self.driver)
        actions.move_to_element(element).perform()
        # 50 | click | css=.gridxRowOver .amount |
        element = self.driver.find_element(By.CSS_SELECTOR, "body")
        actions = ActionChains(self.driver)
        actions.move_to_element(element, 0, 0).perform()
        # 51 | runScript | window.scrollTo(0,106.5) |
        self.driver.find_element(By.CSS_SELECTOR, ".gridxRowOver .moreInfo").click()
        # 52 | click | css=.manage > .icon |
        self.driver.find_element(By.CSS_SELECTOR, ".gridxRowOver .amount").click()
        # 53 | runScript | window.scrollTo(0,200.25) |
        self.driver.execute_script("window.scrollTo(0,106.5)")
        # 54 | mouseOver | linkText=My bills |
        self.driver.find_element(By.CSS_SELECTOR, ".manage > .icon").click()
        # 55 | mouseOut | linkText=My bills |
        self.driver.execute_script("window.scrollTo(0,200.25)")
        # 56 | mouseOver | css=.securePadlockGrey:nth-child(3) |
        element = self.driver.find_element(By.LINK_TEXT, "My bills")
        actions = ActionChains(self.driver)
        actions.move_to_element(element).perform()
        # 57 | mouseOut | css=.securePadlockGrey:nth-child(3) |
        element = self.driver.find_element(By.CSS_SELECTOR, "body")
        actions = ActionChains(self.driver)
        actions.move_to_element(element, 0, 0).perform()
        # 58 | mouseOver | linkText=Bill payment history |
        element = self.driver.find_element(By.CSS_SELECTOR, ".securePadlockGrey:nth-child(3)")
        actions = ActionChains(self.driver)
        actions.move_to_element(element).perform()
        # 59 | click | linkText=Bill payment history |
        element = self.driver.find_element(By.CSS_SELECTOR, "body")
        actions = ActionChains(self.driver)
        actions.move_to_element(element, 0, 0).perform()
        # 60 | runScript | window.scrollTo(0,0) |
        element = self.driver.find_element(By.LINK_TEXT, "Bill payment history")
        actions = ActionChains(self.driver)
        actions.move_to_element(element).perform()
        # 61 | click | id=paybills |
        self.driver.find_element(By.LINK_TEXT, "Bill payment history").click()
        # 62 | runScript | window.scrollTo(0,0) |
        self.driver.execute_script("window.scrollTo(0,0)")
        self.driver.find_element(By.ID, "paybills").click()
        self.driver.execute_script("window.scrollTo(0,0)")

    def extract_account_details(file_path):
        data = tabula.read_pdf(file_path, pages="all")
        data = data[0]
        # user_name = data.get("Customer Name", "")
        customer_ids = data.get("Customer Id")[0]
        account_number = data.get("Account Number")[0]
        currency = data.get("Account Currency")[0]
        month = data.get("From Date")[0]

        return {
            # "user_name": user_name,
            "customer_id": customer_ids,
            "account_number": account_number,
            "currency": currency,
            "month": month,
        }

    # pprint(extract_account_details(pdf_file))

    def extract_account_transactions(file_path):
        data = tabula.read_pdf(file_path, pages="all")
        data_list = []
        for row in data[1:]:
            data_dict = row.to_dict(orient="records")
            data_list.extend(data_dict)
        return data_list

    def extract_account_transactions_csv(file_path):
        # Sample text containing the data
        input_file_path = "output.csv"

        with open(input_file_path, "r") as file:
            sample_text = file.read()
        # Define the regular expression patterns
        customer_info_pattern = r"Branch Number:\s*(\d+)\s+Branch Name:\s+(.*?)\s+"
        statement_details_pattern = r"STATEMENT DATE:\s+(.*?)\s+CUSTOMER NUMBER:\s+(.*?)\s+SEQUENCE NUMBER:\s+(\d+)\s+DESPATCH CODE:\s+(.*?)\s+"
        account_transactions_pattern = r"(\d{2}[A-Za-z]{3}\d{4})\s+(.*?)\s+([\d.,]+)\s+([\d.,]+)(?=(?:\d{2}[A-Za-z]{3}\d{4})|\Z)"
        iban_details_pattern = r"CURRENT ACCOUNT\s+(\d{12})\s+IBAN - (.*?)\s+"
        transaction_summary_pattern = r"(\d{2}[A-Za-z]{3}\d{4})\s+(.*?)(?= \d{2}[A-Za-z]{3}\d{4}|\Z)"
        account_transactions_pattern = r"\"account_transactions\": \[\s+{\s+\"date\":\s+\"(.*?)\",\s+\"transaction_details\":\s+\"(.*?)\",\s+\"deposits\":\s+\"([\d.,]*)\",\s+\"withdrawals\":\s+\"([\d.,]*)\"\s+},\s+{\s+\"date\":\s+\"(.*?)\",\s+\"transaction_details\":\s+\"(.*?)\",\s+\"deposits\":\s+\"0.00\",\s+\"withdrawals\":\s+\"(.*?)\"\s+},\s+{\s+\"date\":\s+\"(.*?)\",\s+\"transaction_details\":\s+\"(.*?)\",\s+\"deposits\":\s+\"([\d.,]*)\",\s+\"withdrawals\":\s+\"([\d.,]*)\"\s+},\s+{\s+\"date\":\s+\"(.*?)\",\s+\"transaction_details\":\s+\"(.*?)\",\s+\"deposits\":\s+\"([\d.,]*)\",\s+\"withdrawals\":\s+\"([\d.,]*)\"\s+},\s+{\s+\"date\":\s+\"(.*?)\",\s+\"transaction_details\":\s+\"(.*?)\",\s+\"deposits\":\s+\"([\d.,]*)\",\s+\"withdrawals\":\s+\"([\d.,]*)\"\s+},\s+{\s+\"date\":\s+\"(.*?)\",\s+\"transaction_details\":\s+\"(.*?)\",\s+\"deposits\":\s+\"([\d.,]*)\",\s+\"withdrawals\":\s+\"([\d.,]*)\"\s+}\s+\],"
        iban_details_pattern = r"\"iban_details\": {\s+\"account_number\":\s+\"(.*?)\",\s+\"iban\":\s+\"(.*?)\"\s+},"
        deposit_details_pattern = r"\"deposit_details\": \[\s+{\s+\"date\":\s+\"(.*?)\",\s+\"deposits\":\s+\"(.*?)\",\s+\"withdrawals\":\s+\"(.*?)\"\s+},\s+{\s+\"date\":\s+\"(.*?)\",\s+\"deposits\":\s+\"(.*?)\",\s+\"withdrawals\":\s+\"(.*?)\"\s+},\s+{\s+\"date\":\s+\"(.*?)\",\s+\"deposits\":\s+\"(.*?)\",\s+\"withdrawals\":\s+\"(.*?)\"\s+},\s+{\s+\"date\":\s+\"(.*?)\",\s+\"deposits\":\s+\"(.*?)\",\s+\"withdrawals\":\s+\"(.*?)\"\s+},\s+{\s+\"date\":\s+\"(.*?)\",\s+\"deposits\":\s+\"(.*?)\",\s+\"withdrawals\":\s+\"(.*?)\"\s+}\s+\],"
        transaction_summary_pattern = r"\"transaction_summary\": \[\s+{\s+\"date\":\s+\"(.*?)\",\s+\"transaction_details\":\s+\"(.*?)\",\s+\"reference\":\s+\"(.*?)\"\s+},\s+{\s+\"date\":\s+\"(.*?)\",\s+\"transaction_details\":\s+\"(.*?)\",\s+\"reference\":\s+\"(.*?)\"\s+},\s+{\s+\"date\":\s+\"(.*?)\",\s+\"transaction_details\":\s+\"(.*?)\",\s+\"reference\":\s+\"(.*?)\"\s+},\s+{\s+\"date\":\s+\"(.*?)\",\s+\"transaction_details\":\s+\"(.*?)\",\s+\"reference\":\s+\"(.*?)\"\s+},\s+{\s+\"date\":\s+\"(.*?)\",\s+\"transaction_details\":\s+\"(.*?)\",\s+\"reference\":\s+\"(.*?)\"\s+},\s+{\s+\"date\":\s+\"(.*?)\",\s+\"transaction_details\":\s+\"(.*?)\",\s+\"reference\":\s+\"(.*?)\"\s+},\s+{\s+\"date\":\s+\"(.*?)\",\s+\"transaction_details\":\s+\"(.*?)\"\s+}\s+\],"
        portfolio_glance_pattern = r"\"portfolio_glance\": \{\s+\"total_deposits_and_investments\": \"(.*?)\",\s+\"total_borrowings\": \"(.*?)\",\s+\"net_position\": \"(.*?)\",\s+\"mortgages\": \"(.*?)\"\s+\}"
        portfolio_summary_pattern = r"\"portfolio_summary\": \{\s+\"deposits\": \[\s+\{\s+\"currency\": \"(.*?)\",\s+\"account_number\": \"(.*?)\",\s+\"credit_limit\": \"(.*?)\"\s+\}\s+\],\s+\"total_deposits\": \"(.*?)\"\s+\}"
        deposit_details_pattern = r"\"deposit_details\": \[\s+\{\s+\"date\": \"(.*?)\",\s+\"deposits\": \"(.*?)\",\s+\"withdrawals\": \"(.*?)\"\s+\},\s+\{\s+\"date\": \"(.*?)\",\s+\"deposits\": \"(.*?)\",\s+\"withdrawals\": \"(.*?)\"\s+\}\s+\]"
        additional_information_pattern = r"\"additional_information\": \[\s+(.*?)\s+\]"

        # Extract data using regular expressions
        customer_info_match = re.search(customer_info_pattern, sample_text)
        statement_details_match = re.search(statement_details_pattern, sample_text)
        portfolio_summary_match = re.search(portfolio_summary_pattern, sample_text)
        account_transactions_matches = re.findall(account_transactions_pattern, sample_text)
        iban_details_match = re.search(iban_details_pattern, sample_text)
        transaction_summary_matches = re.findall(transaction_summary_pattern, sample_text)
        portfolio_glance_matches = re.search(portfolio_glance_pattern, sample_text)
        portfolio_summary_matches = re.search(portfolio_summary_pattern, sample_text)
        deposit_details_matches = re.search(deposit_details_pattern, sample_text)
        additional_information_match = re.search(additional_information_pattern, sample_text)

        # Organize the extracted data into a dictionary
        data = {"composite_statement": {
            "current_page": 1,
            "total_pages": 2,
        }, "statement_details": {
            "statement_date": statement_details_match.group(1),
            "customer_number": statement_details_match.group(2),
            "sequence_number": statement_details_match.group(3),
            "despatch_code": statement_details_match.group(4),
            "portfolio_glance": {
            }
        }, "portfolio_summary": {
            "deposits": [
            ],
            "total_deposits": portfolio_summary_matches.group(5),
        }, "account_transaction": [
            {
                "date": account_transactions_matches.group(1),
                "transaction_details": account_transactions_matches.group(2),
                "deposits": account_transactions_matches.group(3),
                "withdrawals": account_transactions_matches.group(4),
            },
            {
                "date": account_transactions_matches.group(1),
                "transaction_details": account_transactions_matches.group(2),
                "deposits": account_transactions_matches.group(3),
                "withdrawals": account_transactions_matches.group(4),
            },
            {
                "date": account_transactions_matches.group(1),
                "transaction_details": account_transactions_matches.group(2),
                "deposits": account_transactions_matches.group(3),
                "withdrawals": account_transactions_matches.group(4),
            },
            {
                "date": account_transactions_matches.group(1),
                "transaction_details": account_transactions_matches.group(2),
                "deposits": account_transactions_matches.group(3),
                "withdrawals": account_transactions_matches.group(4),
            },
            {
                "date": account_transactions_matches.group(1),
                "transaction_details": account_transactions_matches.group(2),
                "deposits": account_transactions_matches.group(3),
                "withdrawals": account_transactions_matches.group(4),
            },
            {
                "date": account_transactions_matches.group(1),
                "transaction_details": account_transactions_matches.group(2),
                "deposits": account_transactions_matches.group(3),
                "withdrawals": account_transactions_matches.group(4),
            }
        ], "iban_details": {}, "deposit_details": [
            {
                "date": deposit_details_matches.group(1),
                "deposits": deposit_details_matches.group(2),
                "withdrawals": deposit_details_matches.group(3),
            },
            {
                "date": deposit_details_matches.group(1),
                "deposits": deposit_details_matches.group(2),
                "withdrawals": deposit_details_matches.group(3),
            },
            {
                "date": deposit_details_matches.group(1),
                "deposits": deposit_details_matches.group(2),
                "withdrawals": deposit_details_matches.group(3),
            },
            {
                "date": deposit_details_matches.group(1),
                "deposits": deposit_details_matches.group(2),
                "withdrawals": deposit_details_matches.group(3),
            },
            {
                "date": deposit_details_matches.group(1),
                "deposits": deposit_details_matches.group(2),
                "withdrawals": deposit_details_matches.group(3),
            }
        ], "transaction_summary": [
            {
                "date": transaction_summary_matches.group(1),
                "transaction_details": transaction_summary_matches.group(2),
                "reference": transaction_summary_matches.group(3),
            },
            {
                "date": transaction_summary_matches.group(1),
                "transaction_details": transaction_summary_matches.group(2),
                "reference": transaction_summary_matches.group(3),
            },
            {
                "date": transaction_summary_matches.group(1),
                "transaction_details": transaction_summary_matches.group(2),
                "reference": transaction_summary_matches.group(3),
            },
            {
                "date": transaction_summary_matches.group(1),
                "transaction_details": transaction_summary_matches.group(2),
                "reference": transaction_summary_matches.group(3),
            },
            {
                "date": transaction_summary_matches.group(1),
                "transaction_details": transaction_summary_matches.group(2),
                "reference": transaction_summary_matches.group(3),
            },
            {
                "date": transaction_summary_matches.group(1),
                "transaction_details": transaction_summary_matches.group(2),
                "reference": transaction_summary_matches.group(3),
            },
            {
                "date": transaction_summary_matches.group(1),
                "transaction_details": transaction_summary_matches.group(2),
                "reference": transaction_summary_matches.group(3),
            }
        ], "additional_information": additional_information_match}

        # Complete the placeholders with extracted data
        data["composite_statement"]["branch_number"] = customer_info_match.group(1)
        data["composite_statement"]["branch_name"] = customer_info_match.group(2)

        data["portfolio_summary"]["total_deposits"] = portfolio_summary_match.group(1)
        data["statement_details"]["portfolio_glance"]["total_deposits_and_investments"] = portfolio_summary_match.group(
            1)
        data["statement_details"]["portfolio_glance"]["total_borrowings"] = portfolio_summary_match.group(2)
        data["statement_details"]["portfolio_glance"]["net_position"] = portfolio_summary_match.group(3)
        data["statement_details"]["portfolio_glance"]["mortgages"] = portfolio_summary_match.group(4)

        data["iban_details"]["account_number"] = iban_details_match.group(1)
        data["iban_details"]["iban"] = iban_details_match.group(2)

        # Organize account transactions data
        data["account_transactions"] = []
        for transaction_match in account_transactions_matches:
            transaction_data = {
                "date": transaction_match[0],
                "transaction_details": transaction_match[1],
                "deposits": transaction_match[2],
                "withdrawals": transaction_match[3],
            }
            data["account_transactions"].append(transaction_data)

        # Organize transaction summary data
        data["transaction_summary"] = []
        for transaction_summary_match in transaction_summary_matches:
            transaction_summary_data = {
                "date": transaction_summary_match[0],
                "transaction_details": transaction_summary_match[1],
                "reference": transaction_summary_match[2],
            }
            data["transaction_summary"].append(transaction_summary_data)

        # After printing the extracted and organized data, save it to a JSON file
        output_file_path = "extracted_data.json"

        with open(output_file_path, "w") as json_file:
            json.dump(data, json_file, indent=4)

        print("Extracted data has been saved to", output_file_path)

        return output_file_path

################################ OCR  ################################

    def perform_ocr_on_page(page, d):
        pix = page.get_pixmap()
        img = Image.frombytes("RGB", [pix.width, pix.height], pix.samples)
        img = page.preprocess_image(img)

        detected_languages = page.detect_languages(img)
        page_text = ""

        for lang_code in detected_languages:
            lang_text = pytesseract.image_to_string(img, lang=lang_code)
            page_text += lang_text + "\n"

        page_text = page.correct_spelling(page_text, d)
        return page_text

    def perform_ocr_on_pdf(pdf_path):
        pdf_document = fitz.open(pdf_path)
        extracted_text_list = []

        d = enchant.Dict("en_US")

        with concurrent.futures.ThreadPoolExecutor() as executor:
            futures = []
            for page_num in range(pdf_document.page_count):
                page = pdf_document.load_page(page_num)
                futures.append(executor.submit(perform_ocr_on_page, page, d))

            for future in concurrent.futures.as_completed(futures):
                extracted_text_list.append(future.result())

        pdf_document.close()
        return extracted_text_list

    def preprocess_image(image):
        processed_image = image.resize((image.width * 3, image.height * 3))
        return processed_image

    def detect_languages(image):
        detected_languages = ['eng']
        return detected_languages

    def correct_spelling(text, dictionary):
        corrected_text = []
        for word in text.split():
            if dictionary.check(word):
                corrected_text.append(word)
            else:
                suggestions = dictionary.suggest(word)
                if suggestions:
                    corrected_text.append(suggestions[0])
                else:
                    corrected_text.append(word)

        return " ".join(corrected_text)

    def extract_account_transactions_ocr(file_path):
        # data = tabula.read_pdf(file_path, pages="all")

        # Specify the PDF path
        pdf_path = file_path

        # Perform OCR on the PDF
        extracted_text = pdf_path.perform_ocr_on_pdf()

        # Save extracted text to a text file
        output_file_path = 'output_text.json'
        with open(output_file_path, 'w', encoding='utf-8') as output_file:
            for page_num, page_text in enumerate(extracted_text):
                output_file.write(f"Page {page_num + 1} OCR Text:\n{page_text}\n{'=' * 20}\n")

        print(f"Extracted text saved to {output_file_path}")
        return output_file_path
